package linearalgebra.graph;

import java.awt.*;
import java.awt.geom.*;

public class GraphLine extends GraphObject {
	double x;
	double y;
	double slope;
	Color c;
	Line2D line = null;
	
	public GraphLine( double x, double y, double slope, Color c ) {
		this.x = x;
		this.y = y;
		this.slope = slope;
		this.c = c;
	}
	
	public void paint( Graphics2D g ) {
		if( line == null ) {
			if( Double.isInfinite(this.slope) ) {
				line = new Line2D.Double((x), 100, (x), -100);
			} else if( slope == 0.0 ) {
				line = new Line2D.Double(-100, y, 100, y);
			} else {
				line = new Line2D.Double((x+100), (-100*slope), (x-100), (100*slope));
			}
		}
		g.setColor(c);
		g.draw(line);
	}
	//{{DECLARE_CONTROLS
	//}}
}