package linearalgebra.numeric;


public interface NumericVectorInterface extends linearalgebra.VectorInterface, java.lang.Cloneable {
	// vector operations
	public NumericVectorInterface scale( double scalar );
	public NumericVectorInterface linearCombinationEquals( NumericVectorInterface v, double scalar );
	public NumericVectorInterface linearCombination( NumericVectorInterface v, double scalar );
	public NumericVectorInterface projectionOf( NumericVectorInterface v );
	public NumericVectorInterface minus( NumericVectorInterface v );
	// element operations
	public void scaleDimension( int dim, double scalar );
	public void linearCombinationDimension( int src, int dst, double scalar );
	public double innerProduct( NumericVectorInterface v );
	public double[] toArray();
	public void setValue(int index, double value);
	public void setValue(NumericVectorInterface v);
	// data operations
	public double getMean();
	public double getVariance();
	// clonable
	public Object clone();
}