package linearalgebra.symbolic;

public class Multiplication extends PairOperator {
	public Multiplication( SymbolicValue a, SymbolicValue b ) {
		super( a, b );
	}
	
	public int getPrecedence() {
		return MULT;
	}
	
    protected final double doOperation( double left, double right ) {
    	return left * right;
    }
    
    protected final String getOperator() {
    	return "*";
    }
    
    protected PairOperator createNewInstance(SymbolicValue left, SymbolicValue right) {
    	return new Multiplication( left, right );
    }
}