package linearalgebra.symbolic;

import linearalgebra.symbolic.*;

public abstract class UnaryOperator extends linearalgebra.symbolic.AbstractUnknown {
	private SymbolicValue m_child;
	
	public UnaryOperator( SymbolicValue child ) {
		setChild( child );
	}
	
	protected final void setChild( SymbolicValue child ) {
		if( m_child != null ) {
			m_child.removeParent(this);
		}
		m_child = child;
		if( m_child != null ) {
			m_child.addParent(this);
		}
	}
	
    public final SymbolicValue getChild(int index) {
    	if( index == 0 ) {
    		return m_child;
    	}
    	throw new ArrayIndexOutOfBoundsException();
    }

    public final int getChildCount() {
        return 1;
    }
    
    public final double getNumericValue() throws linearalgebra.exception.UnboundValueError {
    	return doOperation(
    		m_child.getNumericValue()
    	);
    }
    
    protected abstract double doOperation( double child );	
}